"use strict";
this.name                   = "EquipmentExpensiveItemColor";
this.author                 = "gilhad";
this.copyright              = "2024 gilhad";
this.description            = "Gray color for expensive equipment in F3 Ship Outfitting screen";
this.licence                = "CC BY-NC-SA 4.0";


this.guiScreenWillChange = function(to,from) {
//	log(this.name,"guiScreenWillChange: "+from+" --> "+to+" ;");
	if (to == "GUI_SCREEN_EQUIP_SHIP" ) {
//		log(this.name,from+" --> "+to);
		this.$updateColors();
	} else if (( to == "GUI_SCREEN_STATUS") && this.$needRevert ) {
//		log(this.name,from+" --> "+to);
		this.$revertColors();
	};
}

this.playerBoughtEquipment = function(equipment, paid) {
//	log(this.name,"playerBoughtEquipment: "+equipment+" ["+paid+" Cr] ;");
	this.$updateColors();
}

this.startUpComplete = function() {
	this.$needRevert = false;	// F5 do not need fix
	
	// HACK use missile to set displayColor, read it and revert it back
	var missileInfo = EquipmentInfo.infoForKey("EQ_MISSILE");
	var tmp = missileInfo.displayColor;
	missileInfo.displayColor = "grayColor";
	this.$grayColor = missileInfo.displayColor.toString();
	//
	// log(this.name,"startUpComplete: missileInfo.displayColor ("+missileInfo.displayColor+") ? =  this.$grayColor ("+this.$grayColor+") : "+(missileInfo.displayColor.toString() == this.$grayColor));
	missileInfo.displayColor = tmp;
	// END HACK
}

this.$grayColor = null;		// get true color for gray, filled in startUpComplete()
this.$needRevert = false;		// F5 do not need fix

this.$updateColors = function() {	// set expensive to gray, cheap to yellow
	this.$needRevert = true;	// we play with colors
	var credits = Math.floor(player.credits*10);
//	log(this.name,"$updateColors ["+credits+" dCr] ;");
	var eq = EquipmentInfo.allEquipment;
	for (var i = 0; i < eq.length; i++) {
		var itm = eq[i];
		var price = itm.calculatedPrice;
		if (price > credits) {	// pricey - go to gray
			if (itm.displayColor == null) {
				itm.displayColor = "grayColor";
			}
		} else {		// cheap - revert
			if ( (itm.displayColor != null ) && (itm.displayColor.toString() == this.$grayColor) ) {
				itm.displayColor = null;
			}
		}
	}
}

this.$revertColors = function() {	// revert everything to yelow
	this.$needRevert = false;		// F5 do not need fix
	var eq = EquipmentInfo.allEquipment;
//	log(this.name,"$revertColors ;");
	for (var i = 0; i < eq.length; i++) {
		var itm = eq[i];
		if ( (itm.displayColor != null ) && (itm.displayColor.toString() == this.$grayColor) ) {
			itm.displayColor = null;
		}
	}
}
